import torch


def fixgauge_qr(A):
    Q, R = torch.qr(A)
    Rsgn = torch.diag(R).sign()
    Q = Q * Rsgn
    R = Rsgn[:, None] * R

    return Q, R


def test_FixQR():
    M, N = 10, 4
    # torch.manual_seed(2)
    A = torch.randn(M, N, dtype=torch.float64)

    Q0, R0 = torch.qr(A)
    Q1, R1 = fixgauge_qr(A)

    print('R0 = ', R0)
    print('R1 = ', R1)
    print('qr0 = ', torch.dist(Q0 @ R0, A))
    print('qr1 = ', torch.dist(Q1 @ R1, A))


if __name__ == "__main__":
    test_FixQR()
